# # # qc standard macros # # #

from qc import *
import qcstartup

def ModuleExists(object):
    for i in GetModuleObjects():
        if IsObject(object,i):
            return 1
    return 0

def GetRootName(object):
    o = object
    n = GetObjectName(o)
    while GetObjectParent(o):
        o = GetObjectParent(o)
        n = GetObjectName(o) + "." + n
    return n

def macroListAvailableModuleClasses(object):
    print qcstartup.GetClassMap().keys()

# load default controls 
from default_controls import *

def macroCreateDefaultControls(object):
    def GetControlInfo(o):
        n = GetObjectName(o)
        if DEFAULT_MODULE_CONTROLS.has_key(n):
            return DEFAULT_MODULE_CONTROLS[n]
        return None
    def GetLinkInfo(ci,l):
        n = GetObjectName(l)
        if ci.has_key(n):
            return ci[n]
        return None
    def GetDataControlInfo(di):
        n = GetObjectName(di)
        if DEFAULT_DATAINFO_CONTROLS.has_key(n):
            return DEFAULT_DATAINFO_CONTROLS[n]
    def CreateWindow(info):
        wc = qcstartup.GetWindowclassObject(info[CLASS_KEY])
        if wc:
            w = CreateWindowObject(wc)
            wx,wy,ww,wh = info[POSITION_KEY]
            px,py = GetModuleObjectPosition(object)
            wx += px
            wy += py
            SetWindowObjectPosition(w,(wx,wy,wx+ww,wy+wh))
            return w
        return None        
    ci = GetControlInfo(object)
    if ci:
        for i in GetLinkObjects(object):            
            li = GetLinkInfo(ci,i)
            if li:
                w = CreateWindow(li)
                if w:
                    SetParentObject(GetObjectParent(object),w)
                    ConnectLinkObject(i,w)
    else:
        for i in GetLinkObjects(object):
            if GetLinkObjectType(i) == QC_CTRL:
                for j in GetLinkObjectDataInfoObjects(i):
                    dci = GetDataControlInfo(j)
                    if dci:
                        w = CreateWindow(dci)
                        if w:
                            SetParentObject(GetObjectParent(object),w)
                            ConnectLinkObject(i,w)
                            break
                        
LAST_TIME = 0
LAST_RUNTIME = 0
    
LAST_SNAPSHOT = {}
    
def macroMakeSnapShot(object):
    global LAST_SNAPSHOT
    if LAST_SNAPSHOT:        
        sum = 0.0
        v = {}
        for i in LAST_SNAPSHOT.items():
            if ModuleExists(i[0]):
                r,nt = GetModuleObjectRunTime(i[0])
                time = r - i[1][0]
                total = nt - i[1][1]
                if time:
                    v[(time,i[0])] = (i[0],time,total)
        sortkeys = v.keys()
        sortkeys.sort()
        for k in sortkeys:
            j = v[k]
            frac = float(j[1])*100.0 / float(j[2])
            sum += frac
            print "[%s]: %.2f%% (%ims/%ims)" % (GetRootName(j[0]),frac,j[1],j[2])
        print "--------------"
        print "Summed: %.2f%%" % sum
    else:
        print "Initializing. To see results, call analyze again."    
    LAST_SNAPSHOT = {}
    for i in GetModuleObjects():
        LAST_SNAPSHOT[i] = GetModuleObjectRunTime(i)

RegisterMacroMethod(QCID_CONSTRUCT,"List All Module Classes...",macroListAvailableModuleClasses)
RegisterMacroMethod(QCID_MODULE,"Create Default Controls",macroCreateDefaultControls)
RegisterMacroMethod(QCID_HOST,"Analyze CPU Load",macroMakeSnapShot)

print "QC Standard Macros loaded."